/******************************************************************************
 * g3DGMV
 * Copyright (C) <1999> <Nick Yost>
 *-----------------------------------------------------------------------------
 *  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ******************************************************************************/

#include <config.h>
#include <gnome.h>
#include <gdk_imlib.h>
#include <gtk/gtk.h>
#include "menus.h"
#include "pixmap.h"
#include "g3DGMVsrc.h"

GtkTooltips *tooltips = NULL;

/* place here for Synchronize with tool menu*/
GtkWidget *Dra_Rec;
GtkWidget *Draw_Line;
GtkWidget *Draw_Free_Hand;
GtkWidget *Fill_Bounded;
GtkWidget *Fill_Replace;
GtkWidget *Rotate_Map;
GtkWidget *Pick_Color_from_Map;
GtkWidget *Map_Settings;
GtkWidget *drawingareaColorBar;
GtkWidget *spinbutton5;
GtkWidget *spinbutton6;
GtkWidget *spinbutton7;
GtkWidget *spinbutton8;
GtkWidget *spinbutton9;
GtkWidget *spinbutton10;
GtkWidget *spinbutton11;
GtkObject *spinbutton11_adj;
GtkWidget *radiobutton1;
GtkWidget *radiobutton2;
GtkWidget *radiobutton3;
GtkWidget *radiobutton4;
GtkWidget *radiobutton5;
// wire frame mode step size
static gdouble oldFrameWidth;
static gdouble oldFrameHeight;
static gdouble oldAx,oldAy,oldAz;
static gint oldStep;

extern GtkWidget *win_main;
extern ElevMap *Map;
extern gint drawtype_motion_event;
extern gint Step;

extern gint EnableSetupFlag;
extern gdouble Wlast_y;
extern gint FrameWidth; 
extern gint FrameHeight;
extern double Ax,Ay,Az;
static int NUM=0, oldNUM=0;



/******************************************************************************
 * Name:         expose_event for color bar
 *-----------------------------------------------------------------------------
 * Description: When the window the gdk_widget_draw routine is called, this
 *              routine is caled. It copies the background pixmap to the 
 *              window.
 *-----------------------------------------------------------------------------
 * Parameters:
 *    widget - a drawable area
 *    event  - 
 ******************************************************************************/
static gint
expose_event                           (GtkWidget    *widget,
                                        GdkEventExpose     *event)
{
  GdkGC *gc;  
  GdkDrawable* drawable;
  gint i=0,n=0,l=0;
  gint colorLevel = (map_get_water_level(Map)-Map->minelev) 
                     * (50/(Map->MaxElev-Map->minelev));

  /* get drawing area */
  drawable = widget->window;

  for (i=0; i<50; i++)
  {
    if(colorLevel > i)
      gc=GetPen(drawable,i+50);
    else
      gc=GetPen(drawable,i+NUM);
    for(n=0; n<3; n++)
        gdk_draw_line(drawable,gc,0,149-(i+n+l),40,149-(i+n+l));
    l=l+n-1;
  }
  return TRUE;
}


/******************************************************************************
 * Name:        mapeupdate
 *-----------------------------------------------------------------------------
 * Description: 
 *-----------------------------------------------------------------------------
 * Parameters:
 *    widget - 
 *    data  - 
 ******************************************************************************/
void mapeupdate(GtkWidget *widget, gpointer data )
{ 
  GdkRectangle update_rect;

  map_set_color_range(Map,NUM);

  if (!strcmp(data,"Cancel"))
  {
    Step=oldStep;
    NUM=oldNUM;
    FrameWidth=oldFrameWidth;
    FrameHeight=oldFrameHeight;
    Ax=oldAx; Ay= oldAy;  Az=oldAz;
    
    if (NUM==0)
      gtk_toggle_button_set_state( GTK_TOGGLE_BUTTON(radiobutton1),TRUE);
    else if(NUM==50) 
      gtk_toggle_button_set_state( GTK_TOGGLE_BUTTON(radiobutton2),TRUE);
    else if(NUM==100)
      gtk_toggle_button_set_state( GTK_TOGGLE_BUTTON(radiobutton3),TRUE);
    else if(NUM==150)
      gtk_toggle_button_set_state( GTK_TOGGLE_BUTTON(radiobutton4),TRUE);
    else if( NUM==200)
      gtk_toggle_button_set_state( GTK_TOGGLE_BUTTON(radiobutton5),TRUE);

    if ( Map->col_list_ptr != NULL && (drawtype_motion_event == 15 || drawtype_motion_event == 14)) 
	Generate_DEM(win_main,0,0,0,0,1);
  }
  else
  {
    oldStep=Step;
    oldNUM=NUM;
    oldFrameWidth=FrameWidth;
    oldFrameHeight=FrameHeight;
    oldAx=Ax; oldAy= Ay;  oldAz=Az;
    
    if ( Map->col_list_ptr != NULL)
    { 
      map_set_color_range(Map,NUM);

      if(drawtype_motion_event == 15 || drawtype_motion_event == 14)
      { 
	Generate_DEM(win_main,0,0,0,0,1);
      }
      else
      {
	Generate_DEM(win_main,1,Ax,Ay,Az,0);
      }
    }

    /* set update rectangle size */
    update_rect.x =0;
    update_rect.y =0;
    update_rect.width  = 40;		      
    update_rect.height = 255;
    gtk_widget_draw (drawingareaColorBar, &update_rect);
  }
    gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton5), (gfloat) Step);
    gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton6), (gfloat)  FrameWidth);
    gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton7), (gfloat)  FrameHeight);
    gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton8), (gfloat) Ax);
    gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton9), (gfloat) Ay);
    gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton10),(gfloat) Az);
}

/*
 * drawColorBar
 *
 */
void drawColorBar(GtkWidget *widget, gpointer data )
{ 
  GdkRectangle update_rect;
  GtkWidget *button1, *button2, *button3, *button4, *button5;

  if (data != NULL)
  {
  button1 = get_widget ((GtkWidget *) data, "radiobutton1"); 
  button2 = get_widget ((GtkWidget *) data, "radiobutton2");
  button3 = get_widget ((GtkWidget *) data, "radiobutton3");
  button4 = get_widget ((GtkWidget *) data, "radiobutton4");
  button5 = get_widget ((GtkWidget *) data, "radiobutton5");

  if (GTK_TOGGLE_BUTTON (button1)->active)
    NUM=0;
  else if(GTK_TOGGLE_BUTTON (button2)->active) 
    NUM=50;
  else if(GTK_TOGGLE_BUTTON (button3)->active)
    NUM=100;
  else if(GTK_TOGGLE_BUTTON (button4)->active)
    NUM=150;
  else if(GTK_TOGGLE_BUTTON (button5)->active)
    NUM=200;

  map_set_color_range(Map,NUM);

  /* update wire frame map */
  if(drawtype_motion_event == 15 || drawtype_motion_event == 14)
    Generate_DEM(win_main,0,0,0,0,1);
  }

 /* set update rectangle size */
  update_rect.x =0;
  update_rect.y =0;
  update_rect.width  = 40;		      
  update_rect.height = 255;
  gtk_widget_draw (drawingareaColorBar, &update_rect);
}

/*
 * Synchronize popup menu and window 
 *
 */
void ButtonClicked(GtkWidget *widget, gpointer data)
{
  GtkCheckMenuItem * check = NULL;

  /* .. check menu item */ 
  if (!strcmp(data,"Draw Rec"))
    check = GTK_CHECK_MENU_ITEM(Dra_Rec);
  else if (!strcmp(data,"Draw Line"))
    check = GTK_CHECK_MENU_ITEM(Draw_Line);
  else if (!strcmp(data,"Draw Free Hand"))
    check = GTK_CHECK_MENU_ITEM(Draw_Free_Hand);
  else if (!strcmp(data,"Fill Bounded"))
    check = GTK_CHECK_MENU_ITEM(Fill_Bounded);
  else if (!strcmp(data,"Fill Replace"))
    check = GTK_CHECK_MENU_ITEM(Fill_Replace); 
  else if (!strcmp(data,"Rotate Map"))
    check = GTK_CHECK_MENU_ITEM(Rotate_Map);
  else if (!strcmp(data,"Pick Color from Map"))
    check = GTK_CHECK_MENU_ITEM(Pick_Color_from_Map); 
  else
    return; 

  /* ... Synchronize the menu state with the button ... */
  gtk_check_menu_item_set_state(check,TRUE);
}

/*
 * Create_popup_button
 *
 * app - application 
 * menu - higher level menu
 * pixmap - pointer to pixmap
 * mask -
 * szTip - Tooltip
 */

GtkWidget * Create_popup_button (GtkWidget *app,
				 GtkWidget *window, 
				 char *szTips,
				 GdkPixmap *pixmap,
				 GdkBitmap *mask)
{
  GtkWidget *button;
  GtkWidget *pixmapwid;
 
  /* a pixmap widget to contain the pixmap */
  pixmapwid  =gtk_pixmap_new( pixmap, mask);
  gdk_pixmap_unref (pixmap);
  gdk_bitmap_unref (mask);
  gtk_object_set_data (GTK_OBJECT (window), "pixmapwid", pixmapwid );
  gtk_widget_show( pixmapwid ); 
 

  /* button1 to contain the pixmap */
  tooltips = gtk_tooltips_new ();
  button = gtk_button_new();
  gtk_button_set_relief(GTK_BUTTON(button),GTK_RELIEF_NONE);
  gtk_object_set_data (GTK_OBJECT (app),"button", button);
  gtk_container_add( GTK_CONTAINER( button ), pixmapwid );
  gtk_widget_show( button );
  gtk_tooltips_set_tip (tooltips, button, szTips,NULL);
  gtk_widget_set_usize (button, 24, 24);

  /* --- Viola -- */
  return (button);
}


/*
 * on_close_activate
 *
 */

void on_close_activate(GtkWidget *button, gpointer data )
{
  /* .. check menu item */ 
  if (!strcmp(data,"close"))
    gtk_widget_set_sensitive(get_toolbar_widget(9),TRUE);  
  else if (!strcmp(data,"Cancel"))
  {
    gtk_widget_set_sensitive(Map_Settings,TRUE);
    EnableSetupFlag = TRUE;
  }
 
}


/*
 * CreateAbutton
 *
 * menu - higher level menu
 * pixmap - pointer to pixmap
 * mask -
 * szTip - Tooltip
 * func - Callback function
 * data - Callback function data
 */



GtkWidget * CreateAbutton (GtkWidget *app,
			   GtkWidget *window, 
			   char *szTips,
			   GdkPixmap *pixmap,
			   GdkBitmap *mask,
			   GtkSignalFunc func,
			   gpointer data)
{
  GtkWidget *button;

  /* call Create_popup_button */
  button = Create_popup_button (app,window,szTips,pixmap,mask);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
                      GTK_SIGNAL_FUNC (func),
		      data);
  /* --- Viola -- */
  return (button);
}

/*
 * create_popup_window
 *
 */

GtkWidget*
create_popup_window (GtkWidget* app)
{
  GtkWidget *popup_window;
  GtkWidget *vbox2;
  GtkWidget *hbox,*hbox2,*hbox3,*hbox4,*hbox5,
            *hbox6,*hbox9;
  GtkWidget *button1;
  GtkWidget *button2;
  GtkWidget *button3;
  GtkWidget *button4;
  GtkWidget *button5;
  GtkWidget *button6;
  GtkWidget *button7;
  GtkWidget *button14;
  GtkWidget *button9;
  GtkWidget *button10; GtkWidget *button11;
  GtkWidget *button12; GtkWidget *button13;
  GdkPixmap *pixmap;
  GdkBitmap *mask;
  GtkWidget *close;
 

  popup_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (popup_window), "popup_window", 
		       popup_window);
  gtk_window_set_title (GTK_WINDOW (popup_window), "Tools");
  gtk_window_set_policy (GTK_WINDOW (popup_window), TRUE, TRUE, FALSE);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (popup_window), "vbox2", vbox2);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (popup_window), vbox2);

  
  /*--- second row of buttons ---*/
  hbox = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (popup_window), "hbox", hbox);
  gtk_widget_show (hbox);
  gtk_container_add (GTK_CONTAINER ( vbox2), hbox);

  /*------ Create Draw Rec button--------- */
  pixmap = gdk_pixmap_create_from_xpm_d( app->window, &mask,
				    &app->style->bg[GTK_STATE_NORMAL],
					rec_xpm );

  button1=CreateAbutton (app,popup_window ,"Draw Rec",pixmap,mask,
			         GTK_SIGNAL_FUNC (ButtonClicked),
			         "Draw Rec");
  gtk_box_pack_start (GTK_BOX (hbox), button1, TRUE, TRUE, 0);

  /*------ Create Draw Line button--------- */
  pixmap = gdk_pixmap_create_from_xpm_d( app->window, &mask,
				    &app->style->bg[GTK_STATE_NORMAL],
					line_xpm );

  button2=CreateAbutton (app,popup_window ,"Draw Line",pixmap,mask,
			 GTK_SIGNAL_FUNC (ButtonClicked),
			 "Draw Line");
  gtk_box_pack_start (GTK_BOX (hbox), button2, TRUE, TRUE, 0);
  
 
  /*--- new row of buttons ---*/
  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (popup_window), "hbox2", hbox2);
  gtk_widget_show (hbox2);
  gtk_container_add (GTK_CONTAINER ( vbox2), hbox2);
  
  /*------ Create Draw Line button--------- */
  pixmap = gdk_pixmap_create_from_xpm_d( app->window, &mask,
				    &app->style->bg[GTK_STATE_NORMAL],
				     free_xpm );

  button6=CreateAbutton (app,popup_window ,"Draw Free Hand",pixmap,mask,
			 GTK_SIGNAL_FUNC (ButtonClicked),
			 "Draw Free Hand");
  gtk_box_pack_start (GTK_BOX (hbox2), button6, TRUE, TRUE, 0);


  /*------ Create Fill Bounded  button--------- */
  pixmap = gdk_pixmap_create_from_xpm_d( app->window, &mask,
				    &app->style->bg[GTK_STATE_NORMAL],
					fill_xpm );

  button3=CreateAbutton (app,popup_window ,"Fill Bounded",pixmap,mask,
			 GTK_SIGNAL_FUNC (ButtonClicked),
			 "Fill Bounded");
  gtk_box_pack_start (GTK_BOX (hbox2), button3, TRUE, TRUE, 0);

 
  /*--- new row of buttons ---*/
  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (popup_window), "hbox3", hbox3);
  gtk_widget_show (hbox3);
  gtk_container_add (GTK_CONTAINER ( vbox2), hbox3);

  /*------ Create Fill replace  button--------- */
   pixmap = gdk_pixmap_create_from_xpm_d( app->window, &mask,
				    &app->style->bg[GTK_STATE_NORMAL],
					replace_xpm );

   button4=CreateAbutton (app,popup_window ,"Fill Replace",pixmap,mask,
			 GTK_SIGNAL_FUNC (ButtonClicked),
			 "Fill Replace");
  gtk_box_pack_start (GTK_BOX (hbox3), button4, TRUE, TRUE, 0);

  /*------ Create Rotate Map  button--------- */
   pixmap = gdk_pixmap_create_from_xpm_d( app->window, &mask,
				    &app->style->bg[GTK_STATE_NORMAL],
					rot_xpm );

  button5=CreateAbutton (app,popup_window ,"Rotate Map",pixmap,mask,
			 GTK_SIGNAL_FUNC (ButtonClicked),
			 "Rotate Map");
  gtk_box_pack_start (GTK_BOX (hbox3), button5, TRUE, TRUE, 0);

 /*--- new row of buttons ---*/
  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (popup_window), "hbox4", hbox4);
  gtk_widget_show (hbox4);
  gtk_container_add (GTK_CONTAINER ( vbox2), hbox4);

  /*------ Create Pick Color from Map  button--------- */
  pixmap = gdk_pixmap_create_from_xpm_d( app->window, &mask,
				    &app->style->bg[GTK_STATE_NORMAL],
				       eyedrop_xpm );

  button7=CreateAbutton (app,popup_window ,"Pick Color from Map",pixmap,mask,
			 GTK_SIGNAL_FUNC (ButtonClicked),
			 "Pick Color from Map");
  gtk_box_pack_start (GTK_BOX (hbox4), button7, TRUE, TRUE, 0);

 /*------ Create select color  button--------- */
  pixmap = gdk_pixmap_create_from_xpm_d( app->window, &mask,
				    &app->style->bg[GTK_STATE_NORMAL],
				       Scolor_xpm );

  button9=CreateAbutton (app,popup_window ,"select color",pixmap,mask,
				 GTK_SIGNAL_FUNC (on_colorBox_activate),
				 NULL);


  gtk_box_pack_start (GTK_BOX (hbox4), button9, TRUE, TRUE, 0);
  /*--- new row of buttons ---*/

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (popup_window), "hbox5", hbox5);
  gtk_widget_show (hbox5);
  gtk_container_add (GTK_CONTAINER ( vbox2), hbox5);

  /*------ Create Zoom Out  button--------- */
  pixmap = gdk_pixmap_create_from_xpm_d( app->window, &mask,
				    &app->style->bg[GTK_STATE_NORMAL],
				     zoomout_xpm );

  button10=CreateAbutton (app,popup_window ,"Zoom Out",pixmap,mask,
				 GTK_SIGNAL_FUNC (ZOOMoutIMAGE),
				 NULL);

  gtk_box_pack_start (GTK_BOX (hbox5), button10, TRUE, TRUE, 0);
 /*------ Create Zoom In  button--------- */
  pixmap = gdk_pixmap_create_from_xpm_d( app->window, &mask,
				    &app->style->bg[GTK_STATE_NORMAL],
				    zoomin_xpm );

  button11=CreateAbutton (app,popup_window ,"Zoom In",pixmap,mask,
				 GTK_SIGNAL_FUNC (ZOOMinIMAGE),
				 NULL);

  gtk_box_pack_start (GTK_BOX (hbox5), button11, TRUE, TRUE, 0);
  /*--- new row of buttons ---*/
 
  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (popup_window), "hbox6", hbox6);
  gtk_widget_show (hbox6);
  gtk_container_add (GTK_CONTAINER ( vbox2), hbox6);

  /*------ Create Flip Vertica  button--------- */
  pixmap = gdk_pixmap_create_from_xpm_d( app->window, &mask,
				    &app->style->bg[GTK_STATE_NORMAL],
				    flipv_xpm );

  button12=CreateAbutton (app,popup_window ,"Flip Vertical",pixmap,mask,
				 GTK_SIGNAL_FUNC (FLIPIMAGEVERTICAL),
				 NULL);

  gtk_box_pack_start (GTK_BOX (hbox6), button12, TRUE, TRUE, 0);
 /*------ Create Flip Horizontal  button--------- */
  pixmap = gdk_pixmap_create_from_xpm_d( app->window, &mask,
				    &app->style->bg[GTK_STATE_NORMAL],
				     fliph_xpm );

  button13=CreateAbutton (app,popup_window ,"Flip Horizontal",pixmap,mask,
				 GTK_SIGNAL_FUNC (FLIPIMAGEHORIZONTAL),
				 NULL);

  gtk_box_pack_start (GTK_BOX (hbox6), button13, TRUE, TRUE, 0);


   /*--- new row of buttons ---*/
  hbox9 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (popup_window), "hbox9", hbox9);
  gtk_widget_show (hbox9);
  gtk_container_add (GTK_CONTAINER ( vbox2), hbox9);
  /*------ Create Rotate Right button--------- */
  pixmap = gdk_pixmap_create_from_xpm_d( app->window, &mask,
				    &app->style->bg[GTK_STATE_NORMAL],
				    rotate_xpm );

  button14=CreateAbutton (app,popup_window ,"Rotate Right",pixmap,mask,
				 GTK_SIGNAL_FUNC (ROTATEIMAGE),
				 NULL);

  gtk_box_pack_start (GTK_BOX (hbox9), button14, TRUE, TRUE, 0);
  /*------ Create close window  button--------- */
  pixmap = gdk_pixmap_create_from_xpm_d( app->window, &mask,
				    &app->style->bg[GTK_STATE_NORMAL],
				    door_xpm );

  close=Create_popup_button (app,popup_window ,"Close Window",pixmap,mask);

  gtk_box_pack_start (GTK_BOX (hbox9), close, TRUE, TRUE, 0);
  
  gtk_signal_connect(GTK_OBJECT(close),"clicked",
		     GTK_SIGNAL_FUNC(on_close_activate),"close");
  gtk_tooltips_set_tip (tooltips, close, "close" ,NULL);
  gtk_widget_set_usize (close, 24, 24);
  gtk_signal_connect_object(GTK_OBJECT(close),"clicked",
			    (GtkSignalFunc) gtk_widget_destroy,
			    GTK_OBJECT (popup_window));
   return popup_window;

  }




/*
 * create_popup_menu
 *
 */

GtkWidget*
create_popup_menu (GtkWidget* app)
{
  GtkWidget *menu1;
  GtkWidget *glade_menuitem;
  GtkWidget *glade_menuitem2;
  GtkWidget *glade_menuitem3;
  GtkWidget *glade_menuitem4;
  GtkWidget *Flat_Map;
  GtkWidget *Rotate_Wire;
  GtkWidget *Move_Wire;
  GtkWidget *Find;
  GtkWidget *hseparator1,*hseparator2,*hseparator3,
            *hseparator4,*hseparator5;
  GSList *group= NULL;

  menu1 = gtk_menu_new ();
  gtk_widget_show (menu1);
 

  glade_menuitem = gtk_menu_item_new_with_label ("Position Default");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (menu1), glade_menuitem);
  glade_menuitem2 = gtk_menu_item_new_with_label ("Position Rotated");
  gtk_widget_show (glade_menuitem2);
  gtk_menu_append (GTK_MENU (menu1), glade_menuitem2);

  hseparator4 = gtk_menu_item_new ();
  gtk_widget_show (hseparator4);
  gtk_container_add (GTK_CONTAINER (menu1), hseparator4);

  glade_menuitem3 = gtk_check_menu_item_new_with_label ("Map DLG");
  gtk_object_set_data (GTK_OBJECT (app), "glade_menuitem3",glade_menuitem3);
  gtk_menu_append (GTK_MENU (menu1), glade_menuitem3);
  gtk_widget_show (glade_menuitem3);
  glade_menuitem4 = gtk_check_menu_item_new_with_label ("Map Line");
  gtk_object_set_data (GTK_OBJECT (app), "glade_menuitem4",glade_menuitem4);
  gtk_menu_append (GTK_MENU (menu1), glade_menuitem4);
  gtk_widget_show (glade_menuitem4);

 
  gtk_signal_connect (GTK_OBJECT (glade_menuitem), "activate",
                      GTK_SIGNAL_FUNC (on_Map_normal_activate), 
		      (gpointer) app); 
  gtk_signal_connect (GTK_OBJECT (glade_menuitem2), "activate",
                      GTK_SIGNAL_FUNC (on_Map_3D_activate), 
		      (gpointer) app); 
  gtk_signal_connect (GTK_OBJECT (glade_menuitem3), "activate",
                      GTK_SIGNAL_FUNC (on_Map_DLG_activate), 
		      (gpointer) app); 
  gtk_signal_connect (GTK_OBJECT (glade_menuitem4), "activate",
                      GTK_SIGNAL_FUNC (on_Map_line_activate), 
		      (gpointer) app); 

  //gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu4), optionmenu4_menu);

  hseparator1 = gtk_menu_item_new ();
  gtk_object_set_data (GTK_OBJECT (menu1), "hseparator1", hseparator1);
  gtk_widget_show (hseparator1);
  gtk_container_add (GTK_CONTAINER (menu1), hseparator1);

  Dra_Rec = gtk_radio_menu_item_new_with_label (group,"Draw Rec");
  group = gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(Dra_Rec));
  gtk_object_set_data (GTK_OBJECT (menu1), "Draw_Rec", Dra_Rec);
  gtk_widget_show (Dra_Rec);
  gtk_container_add (GTK_CONTAINER (menu1), Dra_Rec);
  gtk_signal_connect (GTK_OBJECT (Dra_Rec), "toggled",
                      GTK_SIGNAL_FUNC (draw_area_event),
                      "1");                     
  gtk_signal_connect (GTK_OBJECT (Dra_Rec), "toggled",
		      GTK_SIGNAL_FUNC (on_Map_normal_activate), 
		      (gpointer) app);
                      

  Draw_Line = gtk_radio_menu_item_new_with_label (group,"Draw Line");
  group = gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(Draw_Line));
  gtk_object_set_data (GTK_OBJECT (menu1), "Draw_Line", Draw_Line);
  gtk_widget_show (Draw_Line);
  gtk_container_add (GTK_CONTAINER (menu1), Draw_Line);
  gtk_signal_connect (GTK_OBJECT (Draw_Line), "toggled",
                      GTK_SIGNAL_FUNC (draw_area_event),
                      "2");
 gtk_signal_connect (GTK_OBJECT (Draw_Line), "toggled",
		      GTK_SIGNAL_FUNC (on_Map_normal_activate), 
		      (gpointer) app);

  Draw_Free_Hand = gtk_radio_menu_item_new_with_label (group,"Draw Free Hand");
  group = gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(Draw_Free_Hand));
  gtk_object_set_data (GTK_OBJECT (menu1), "Draw_Free_Hand", Draw_Free_Hand);
  gtk_widget_show (Draw_Free_Hand);
  gtk_container_add (GTK_CONTAINER (menu1), Draw_Free_Hand);
  gtk_signal_connect (GTK_OBJECT (Draw_Free_Hand), "toggled",
                      GTK_SIGNAL_FUNC (draw_area_event),
                      "6");
  gtk_signal_connect (GTK_OBJECT (Draw_Free_Hand), "toggled",
		      GTK_SIGNAL_FUNC (on_Map_normal_activate), 
		      (gpointer) app);

 
  hseparator2 = gtk_menu_item_new ();
  gtk_object_set_data (GTK_OBJECT (menu1), "hseparator2", hseparator2);
  gtk_widget_show (hseparator2);
  gtk_container_add (GTK_CONTAINER (menu1), hseparator2);

  Fill_Bounded = gtk_radio_menu_item_new_with_label (group,"Fill Bounded");
  group = gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(Fill_Bounded));
  gtk_object_set_data (GTK_OBJECT (menu1), "Fill_Bounded", Fill_Bounded);
  gtk_widget_show (Fill_Bounded);
  gtk_container_add (GTK_CONTAINER (menu1), Fill_Bounded);
  gtk_signal_connect (GTK_OBJECT (Fill_Bounded), "toggled",
                      GTK_SIGNAL_FUNC (draw_area_event),
                      "3");
  gtk_signal_connect (GTK_OBJECT (Fill_Bounded), "toggled",
		      GTK_SIGNAL_FUNC (on_Map_normal_activate), 
		      (gpointer) app);

  Fill_Replace = gtk_radio_menu_item_new_with_label (group,"Fill Replace");
  group = gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(Fill_Replace));
  gtk_object_set_data (GTK_OBJECT (menu1), "Fill_Replace", Fill_Replace);
  gtk_widget_show (Fill_Replace);
  gtk_container_add (GTK_CONTAINER (menu1), Fill_Replace);
  gtk_signal_connect (GTK_OBJECT (Fill_Replace), "toggled",
                      GTK_SIGNAL_FUNC (draw_area_event),
                      "4");
  gtk_signal_connect (GTK_OBJECT (Fill_Replace), "toggled",
		      GTK_SIGNAL_FUNC (on_Map_normal_activate), 
		      (gpointer) app);
 
  hseparator3 = gtk_menu_item_new ();
  gtk_object_set_data (GTK_OBJECT (menu1), "hseparator3", hseparator3);
  gtk_widget_show (hseparator3);
  gtk_container_add (GTK_CONTAINER (menu1), hseparator3);

  Pick_Color_from_Map = gtk_radio_menu_item_new_with_label (group,"Pick Color from Map");
  group = gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(Pick_Color_from_Map));
  gtk_object_set_data (GTK_OBJECT (menu1), "Pick_Color_from_Map",
		       Pick_Color_from_Map);
  gtk_widget_show (Pick_Color_from_Map);
  gtk_container_add (GTK_CONTAINER (menu1), Pick_Color_from_Map);
  gtk_signal_connect (GTK_OBJECT (Pick_Color_from_Map), "toggled",
                      GTK_SIGNAL_FUNC (draw_area_event),
                      "7");
  gtk_signal_connect (GTK_OBJECT (Pick_Color_from_Map), "toggled",
		      GTK_SIGNAL_FUNC (on_Map_normal_activate), 
		      (gpointer) app);

  Find= gtk_radio_menu_item_new_with_label (group,"Find Position on Map");
  group = gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(Find));
  gtk_object_set_data (GTK_OBJECT (menu1), "Find",
		       Find);
  gtk_widget_show (Find);
  gtk_container_add (GTK_CONTAINER (menu1), Find);
  gtk_signal_connect (GTK_OBJECT (Find), "toggled",
                      GTK_SIGNAL_FUNC (draw_area_event),
                      "8");
  gtk_signal_connect (GTK_OBJECT (Find), "toggled",
		      GTK_SIGNAL_FUNC (on_Map_normal_activate), 
		      (gpointer) app);

  hseparator5 = gtk_menu_item_new ();
  gtk_object_set_data (GTK_OBJECT (menu1), "hseparator5", hseparator5);
  gtk_widget_show (hseparator5);
  gtk_container_add (GTK_CONTAINER (menu1), hseparator5);

  Flat_Map = gtk_radio_menu_item_new_with_label (group,"Default Map");
  group = gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(Flat_Map));
  gtk_object_set_data (GTK_OBJECT (menu1), "Flat_Map", Flat_Map);
  gtk_object_set_data (GTK_OBJECT (win_main), "Flat_Map", Flat_Map);
  gtk_widget_show (Flat_Map);
  gtk_container_add (GTK_CONTAINER (menu1), Flat_Map);
  gtk_signal_connect (GTK_OBJECT (Flat_Map), "toggled",
                      GTK_SIGNAL_FUNC (draw_area_event),
		      "10");
  gtk_signal_connect (GTK_OBJECT (Flat_Map), "activate",
                      GTK_SIGNAL_FUNC (on_Map_Flat_activate), 
		      (gpointer) app);

  Rotate_Map = gtk_radio_menu_item_new_with_label (group,"Rotate Map");
  group = gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(Rotate_Map));
  gtk_object_set_data (GTK_OBJECT (menu1), "Rotate_Map", Rotate_Map);
  gtk_widget_show (Rotate_Map);
  gtk_container_add (GTK_CONTAINER (menu1), Rotate_Map);
  gtk_signal_connect (GTK_OBJECT (Rotate_Map), "toggled",
                      GTK_SIGNAL_FUNC (draw_area_event),
		      "5");

  hseparator5 = gtk_menu_item_new ();
  gtk_object_set_data (GTK_OBJECT (menu1), "hseparator5", hseparator5);
  gtk_widget_show (hseparator5);
  gtk_container_add (GTK_CONTAINER (menu1), hseparator5);


  Rotate_Wire = gtk_radio_menu_item_new_with_label (group,"Rotate Wire Frame");
  group = gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(Rotate_Wire));
  gtk_object_set_data (GTK_OBJECT (menu1), "Rotate_Wire", Rotate_Wire);
  gtk_widget_show (Rotate_Wire);
  gtk_container_add (GTK_CONTAINER (menu1), Rotate_Wire);
  gtk_signal_connect (GTK_OBJECT (Rotate_Wire), "toggled",
                      GTK_SIGNAL_FUNC (draw_area_event),
		      "9");
  gtk_signal_connect (GTK_OBJECT (Rotate_Wire), "toggled",
                      GTK_SIGNAL_FUNC (on_Map_line_activate), 
		      (gpointer) app);

  Move_Wire = gtk_radio_menu_item_new_with_label (group,"Move Wire Frame");
  group = gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(Move_Wire));
  gtk_object_set_data (GTK_OBJECT (menu1), "Move_Wire", Move_Wire);
  gtk_widget_show (Move_Wire);
  gtk_container_add (GTK_CONTAINER (menu1), Move_Wire);
  gtk_signal_connect (GTK_OBJECT (Move_Wire), "toggled",
                      GTK_SIGNAL_FUNC (draw_area_event),
		      "0");
  gtk_signal_connect (GTK_OBJECT (Move_Wire), "toggled",
                      GTK_SIGNAL_FUNC (on_Map_line_activate), 
		      (gpointer) app);

  hseparator3 = gtk_menu_item_new ();
  gtk_object_set_data (GTK_OBJECT (menu1), "hseparator3", hseparator3);
  gtk_widget_show (hseparator3);
  gtk_container_add (GTK_CONTAINER (menu1), hseparator3);

  Map_Settings = gtk_menu_item_new_with_label ("Custom...");
  gtk_object_set_data (GTK_OBJECT (menu1), "Map_Settings", Map_Settings);
  gtk_widget_show (Map_Settings);
  gtk_container_add (GTK_CONTAINER (menu1), Map_Settings);
  gtk_signal_connect (GTK_OBJECT (Map_Settings), "activate",
                      GTK_SIGNAL_FUNC (on_DailogFrame_activate),
		      (gpointer) app);
 

  return menu1;
  }


/*
 * create_FrameDialog
 *
 */
GtkWidget*
create_FrameDialog (GtkWidget* app)
{
  GtkWidget *FrameDialog;
  GtkWidget *dialog_vbox3;
  GtkWidget *fixed2;
  GtkObject *spinbutton5_adj;
  GtkWidget *label1;
  GtkObject *spinbutton6_adj;
  GtkWidget *label2;
  GtkObject *spinbutton7_adj;
  GtkWidget *label3;
  GtkObject *spinbutton8_adj;
  GtkWidget *label4;
  GtkObject *spinbutton9_adj;
  GtkWidget *label5;
  GtkObject *spinbutton10_adj;
  GtkWidget *label6;
  GtkWidget *label7;
  GtkWidget *viewport1;
  GtkWidget *dialog_action_area3;
  GtkWidget *hbuttonbox2;
  GtkWidget *ExitButton;
  GtkWidget *button7;
  GtkWidget *button8;
  GSList *fixed_group = NULL;


  /*  back up old map values */
 
  oldNUM=NUM;
  oldStep=Step;
  oldFrameWidth=FrameWidth;
  oldFrameHeight=FrameHeight;
  oldAx=Ax; oldAy= Ay;  oldAz=Az;

  FrameDialog = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "FrameDialog", FrameDialog);
  gtk_window_set_title (GTK_WINDOW (FrameDialog), "Frame Controls");
  gtk_window_set_policy (GTK_WINDOW (FrameDialog), TRUE, TRUE, FALSE);

  dialog_vbox3 = GTK_DIALOG (FrameDialog)->vbox;
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "dialog_vbox3", dialog_vbox3);
  gtk_widget_show (dialog_vbox3);

  fixed2 = gtk_fixed_new ();
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "fixed2", fixed2);
  gtk_widget_show (fixed2);
  gtk_box_pack_start (GTK_BOX (dialog_vbox3), fixed2, TRUE, TRUE, 0);

  /* .......................... Frame size .......................... */
  spinbutton5_adj = gtk_adjustment_new (Step, 1, 100, 1, 10, 10);
  spinbutton5 = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton5_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "spinbutton5", spinbutton5);
  gtk_widget_show (spinbutton5);
  gtk_fixed_put (GTK_FIXED (fixed2), spinbutton5, 32, 40);
  gtk_widget_set_usize (spinbutton5, 45, 22);
  gtk_signal_connect(GTK_OBJECT(spinbutton5),"changed",
		     GTK_SIGNAL_FUNC(on_Spinner_Changed),"spinbutton5");

  label1 = gtk_label_new ("Step Size");
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "label1", label1);
  gtk_widget_show (label1);
  gtk_fixed_put (GTK_FIXED (fixed2), label1, 32, 24);
  gtk_widget_set_usize (label1, 60, 16);

  spinbutton6_adj = gtk_adjustment_new (FrameWidth, 0, 400, 1, 10, 10);
  spinbutton6 = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton6_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "spinbutton6", spinbutton6);
  gtk_widget_show (spinbutton6);
  gtk_fixed_put (GTK_FIXED (fixed2), spinbutton6, 100, 40);
  gtk_widget_set_usize (spinbutton6, 45, 22);
  gtk_signal_connect(GTK_OBJECT(spinbutton6),"changed",
		     GTK_SIGNAL_FUNC(on_Spinner_Changed),"spinbutton6");

  label2 = gtk_label_new ("Width");
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "label2", label2);
  gtk_widget_show (label2);
  gtk_fixed_put (GTK_FIXED (fixed2), label2, 100,24);
  gtk_widget_set_usize (label2,38, 16);

  spinbutton7_adj = gtk_adjustment_new (FrameHeight, 0, 400, 1, 10, 10);
  spinbutton7 = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton7_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "spinbutton7", spinbutton7);
  gtk_widget_show (spinbutton7);
  gtk_fixed_put (GTK_FIXED (fixed2), spinbutton7, 164, 40);
  gtk_widget_set_usize (spinbutton7, 45, 22);
  gtk_signal_connect(GTK_OBJECT(spinbutton7),"changed",
		     GTK_SIGNAL_FUNC(on_Spinner_Changed),"spinbutton7");

  label3 = gtk_label_new ("Hieght");
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "label3", label3);
  gtk_widget_show (label3);
  gtk_fixed_put (GTK_FIXED (fixed2), label3, 164, 24);
  gtk_widget_set_usize (label3, 40, 16); 


  /* .......................... Frame Rotation .......................... */
  spinbutton8_adj = gtk_adjustment_new (Ax, 0, 360, 1, 1, 1);
  spinbutton8 = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton8_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "spinbutton8", spinbutton8);
  gtk_widget_show (spinbutton8);
  gtk_fixed_put (GTK_FIXED (fixed2), spinbutton8, 32, 80);
  gtk_widget_set_usize (spinbutton5, 45, 22);
  gtk_signal_connect(GTK_OBJECT(spinbutton8),"changed",
		     GTK_SIGNAL_FUNC(on_Spinner_Changed),"spinbutton8");

  label4 = gtk_label_new ("X Axis");
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "label4", label4);
  gtk_widget_show (label4);
  gtk_fixed_put (GTK_FIXED (fixed2), label4, 32, 64);
  gtk_widget_set_usize (label1, 60, 16);

  spinbutton9_adj = gtk_adjustment_new (Ay, 0, 360, 1, 10, 10);
  spinbutton9 = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton9_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "spinbutton9", spinbutton9);
  gtk_widget_show (spinbutton9);
  gtk_fixed_put (GTK_FIXED (fixed2), spinbutton9, 100, 80);
  gtk_widget_set_usize (spinbutton9, 45, 22);
  gtk_signal_connect(GTK_OBJECT(spinbutton9),"changed",
		     GTK_SIGNAL_FUNC(on_Spinner_Changed),"spinbutton9");

  label5 = gtk_label_new ("Y Axis");
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "label5", label5);
  gtk_widget_show (label5);
  gtk_fixed_put (GTK_FIXED (fixed2), label5, 100,64);
  gtk_widget_set_usize (label5,38, 16);

  spinbutton10_adj = gtk_adjustment_new (Az, 0, 360, 1, 10, 10);
  spinbutton10 = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton10_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "spinbutton10", spinbutton10);
  gtk_widget_show (spinbutton10);
  gtk_fixed_put (GTK_FIXED (fixed2), spinbutton10, 164, 80);
  gtk_widget_set_usize (spinbutton10, 45, 22);
  gtk_signal_connect(GTK_OBJECT(spinbutton10),"changed",
		     GTK_SIGNAL_FUNC(on_Spinner_Changed),"spinbutton10");

  label6 = gtk_label_new ("Z Axis");
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "label6", label6);
  gtk_widget_show (label6);
  gtk_fixed_put (GTK_FIXED (fixed2), label6, 164, 64);
  gtk_widget_set_usize (label6, 40, 16); 

	
	
  spinbutton11_adj = gtk_adjustment_new (map_get_water_level(Map), Map->minelev, Map->MaxElev, 1, 10, 10);
  spinbutton11 = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton11_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "spinbutton11", spinbutton11);
  gtk_widget_show (spinbutton11);
  gtk_fixed_put (GTK_FIXED (fixed2), spinbutton11, 32, 130);
  gtk_widget_set_usize (spinbutton11, 85, 22);
  gtk_signal_connect(GTK_OBJECT(spinbutton11),"changed",
		     GTK_SIGNAL_FUNC(on_Spinner_Changed),"spinbutton11");
  gtk_signal_connect(GTK_OBJECT(spinbutton11),"changed",
		     GTK_SIGNAL_FUNC(drawColorBar),NULL);
 

  label7 = gtk_label_new ("Water Level");
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "label7", label7);
  gtk_widget_show (label7);
  gtk_fixed_put (GTK_FIXED (fixed2), label7, 32, 114);
  gtk_widget_set_usize (label7, 80, 16);

   /*The Selection buttons for map color*/

  radiobutton1 = gtk_radio_button_new_with_label (fixed_group, "Land");
  fixed_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton1));
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "radiobutton1", radiobutton1);
  gtk_widget_show (radiobutton1);
  gtk_fixed_put (GTK_FIXED (fixed2), radiobutton1, 215, 24);
  gtk_widget_set_usize (radiobutton1, 60, 24);
  gtk_signal_connect (GTK_OBJECT (radiobutton1), "clicked",
		      GTK_SIGNAL_FUNC (drawColorBar), (gpointer) FrameDialog);

  radiobutton2 = gtk_radio_button_new_with_label (fixed_group, "Blue");
  fixed_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton2));
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "radiobutton2", radiobutton2);
  gtk_widget_show (radiobutton2);
  gtk_fixed_put (GTK_FIXED (fixed2), radiobutton2, 215, 56);
  gtk_widget_set_usize (radiobutton2, 60, 24);
  gtk_signal_connect (GTK_OBJECT (radiobutton2), "clicked",
		      GTK_SIGNAL_FUNC (drawColorBar), (gpointer) FrameDialog);

  radiobutton3 = gtk_radio_button_new_with_label (fixed_group, "Green");
  fixed_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton3));
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "radiobutton3", radiobutton3);
  gtk_widget_show (radiobutton3);
  gtk_fixed_put (GTK_FIXED (fixed2), radiobutton3, 215, 88);
  gtk_widget_set_usize (radiobutton3, 60, 24);
  gtk_signal_connect (GTK_OBJECT (radiobutton3), "clicked",
		      GTK_SIGNAL_FUNC (drawColorBar), (gpointer) FrameDialog);

  radiobutton4 = gtk_radio_button_new_with_label (fixed_group, "Red");
  fixed_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton4));
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "radiobutton4", radiobutton4);
  gtk_widget_show (radiobutton4);
  gtk_fixed_put (GTK_FIXED (fixed2), radiobutton4, 215, 120);
  gtk_widget_set_usize (radiobutton4, 60, 24);
  gtk_signal_connect (GTK_OBJECT (radiobutton4), "clicked",
		      GTK_SIGNAL_FUNC (drawColorBar), (gpointer) FrameDialog);

  radiobutton5 = gtk_radio_button_new_with_label (fixed_group, "Gray");
  fixed_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton5));
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "radiobutton5", radiobutton5);
  gtk_widget_show (radiobutton5);
  gtk_fixed_put (GTK_FIXED (fixed2), radiobutton5, 215, 152);
  gtk_widget_set_usize (radiobutton5, 60, 24);
  gtk_signal_connect (GTK_OBJECT (radiobutton5), "clicked",
		      GTK_SIGNAL_FUNC (drawColorBar),(gpointer) FrameDialog);

  /* ........................set up draw area................ */
  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "viewport1", viewport1);
  gtk_fixed_put (GTK_FIXED (fixed2), viewport1,280,23);
  gtk_widget_set_usize (viewport1,40,150);
  gtk_widget_show (viewport1);

  drawingareaColorBar = gtk_drawing_area_new ();
  gtk_drawing_area_size(GTK_DRAWING_AREA (drawingareaColorBar),40,256);
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "drawingareaColorBar", 
		       drawingareaColorBar);
  gtk_container_add (GTK_CONTAINER (viewport1), drawingareaColorBar);
  gtk_widget_show (drawingareaColorBar);

 /* Signals used to handle backing pixmap */
  gtk_signal_connect(GTK_OBJECT(drawingareaColorBar), "expose_event",
		    (GtkSignalFunc) expose_event,
		     NULL);

  gtk_widget_set_events (drawingareaColorBar, GDK_EXPOSURE_MASK);



  dialog_action_area3 = GTK_DIALOG (FrameDialog)->action_area;
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "dialog_action_area3", dialog_action_area3);
  gtk_widget_show (dialog_action_area3);
  gtk_container_border_width (GTK_CONTAINER (dialog_action_area3), 10);

  hbuttonbox2 = gtk_hbutton_box_new ();
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "hbuttonbox2", hbuttonbox2);
  gtk_widget_show (hbuttonbox2);
  gtk_box_pack_start (GTK_BOX (dialog_action_area3), hbuttonbox2, TRUE, TRUE, 0);

  ExitButton = gtk_button_new_with_label ("Exit");
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "ExitButton", ExitButton);
  gtk_object_set_data (GTK_OBJECT (win_main), "ExitButton", ExitButton);
  gtk_widget_show (ExitButton);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), ExitButton);

  gtk_signal_connect(GTK_OBJECT(ExitButton),"clicked",
		     GTK_SIGNAL_FUNC(on_close_activate),"Cancel");
  gtk_signal_connect_object(GTK_OBJECT(ExitButton),"clicked",
			    (GtkSignalFunc) gtk_widget_destroy,
			    GTK_OBJECT (FrameDialog));

  button7 = gtk_button_new_with_label ("Cancel");
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "button7", button7);
  gtk_widget_show (button7);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), button7);
  gtk_signal_connect(GTK_OBJECT(button7),"clicked",
		     (GtkSignalFunc) mapeupdate,
		     "Cancel");

  button8 = gtk_button_new_with_label ("Accept");
  gtk_object_set_data (GTK_OBJECT (FrameDialog), "button8", button8);
  gtk_widget_show (button8);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), button8);
  gtk_signal_connect(GTK_OBJECT(button8),"clicked",
		    (GtkSignalFunc) mapeupdate,
		     "Accept");
  

  return FrameDialog;
}
